--!parent
--!encoding=utf-8 äöü

global $

property pAppName
property pAppVersion

-- widgets
property pMainWin
property pStatusBar

-- structure
property pTreeWidgetStructure

-- browse
property pTableWidgetBrowse
property pComboBoxBrowseTable
property pToolButtonRefresh
property pPushButtonNewRecord
property pPushButtonDeleteRecord
property pLabelRecordset
property pToolButtonBegin
property pToolButtonPrevious
property pToolButtonNext
property pToolButtonEnd

property pPushButtonGoto
property pLineEditGoto

-- UDF dialog
property pDialogUDF
property pCheckBoxAggregate
property pLabelFinalize
property pLineEditFinalize

-- Edit dialog
property pDialogEdit
property pDialogEditPlainTextEditValue
property pDialogEditCheckBoxNull

-- Field Dialog
property pDialogField
property pDialogFieldLineEditName
--property pDialogFieldLineEditType
property pDialogFieldComboBoxType
property pDialogFieldLineEditDefault
property pDialogFieldCheckBoxNotNull

-- execute SQL
property pPlainTextEditSQL
property pPushButtonExecute
property pLineEditMessage
property pTableWidgetResults

-- log
property pPlainTextEditLog

-- objects
property pActions
property pState
property pActiveEncodingAction

-- vars
property pSX
property pErr
property pEncoding
property pCurrentRowOffset
property pPassphrase
property pDatabases
property pTableInfo
property pLingoCompileError
property pShowROWID

-- settings
property pBrowseRowsPerPage
property pExecuteMaxRows
property pSqlExportFullInserts
property pSqlExportEOL
property pCsvEOL
property pCsvDelim
property pCsvEnclosure

----------------------------------------
--
----------------------------------------
on new (me)

  -- libs
  $.import("csv")
  $.import("file")
  $.import("json")
  $.import("qt")
  $.import("regex")
  $.import("shell")
  $.import("sqlite")
  $.import("string")

  me.pAppName = "QLingoSQLite"
  me.pAppVersion = 3

  me.pErr = []
  me.pEncoding = "utf-8"
  me.pCurrentRowOffset = 0
  me.pDatabases = [:]
  me.pShowROWID = FALSE
  me.pPassphrase = ""

  -- load settings
  settings = $.Qt.Settings.new($.Qt.QSettings.IniFormat, $.PATH&"settings.ini")
  me.pBrowseRowsPerPage = integer(settings.value("BrowseRowsPerPage"))
  me.pExecuteMaxRows = integer(settings.value("ExecuteMaxRows"))
  me.pSqlExportFullInserts = integer(settings.value("SqlExportFullInserts"))
  me.pSqlExportEOL = value("$."&settings.value("SqlExportEOL"))
  if voidP(me.pSqlExportEOL) then me.pSqlExportEOL=$.CRLF
  me.pCsvEOL = value("$."&settings.value("CsvEOL"))
  if voidP(me.pCsvEOL) then me.pCsvEOL=$.CRLF
  me.pCsvDelim = string(settings.value("CsvDelim"))
  if me.pCsvDelim="TAB" then me.pCsvDelim = TAB
  me.pCsvEnclosure = string(settings.value("CsvEnclosure"))

  $.Qt._qx.loadResourceFile($.PATH&"resources\icons\icons.rcc")

  loader = $.Qt.UiLoader.new()

  ----------------------------------------
  -- MainWindow
  ----------------------------------------
  me.pMainWin = loader.load($.@("resources/main.ui"))
  me.pMainWin.connect($.Qt.Event.Close, me, #slotExit, TRUE) -- ignore close

  -- set Qt drop callback
  me.pMainWin.setAcceptDrops(TRUE)
  $.Qt.registerDropHandler(me.pMainWin, #slotDrop, me)

  me.pStatusBar = me.pMainWin.findChild("statusbar", #StatusBar)

  -- log
  me.pPlainTextEditLog = me.pMainWin.findChild("plainTextEditLog", #PlainTextEdit)
  me.pSX = $.include($.PATH&"resources\sqllogger.ls").new(me.pPlainTextEditLog)
  $.inherit(me.pSX, $.sqlite)

  ----------------------------------------
  -- UDF Dialog
  ----------------------------------------
  me.pDialogUDF = loader.load($.@("resources/udf.ui"), me.pMainWin)
  me.pDialogUDF.setParent(me.pMainWin)

  buttonBox = me.pDialogUDF.findChild("buttonBox", #DialogButtonBox)
  buttonBox.connect(#accepted, me, #slotDialogUDFAccepted)

  me.pCheckBoxAggregate = me.pDialogUDF.findChild("checkBoxAggregate", #CheckBox)
  me.pCheckBoxAggregate.connect(#toggled, me, #slotCheckBoxAggregateToggled)

  me.pLabelFinalize = me.pDialogUDF.findChild("labelFinalize", #Label)
  me.pLineEditFinalize = me.pDialogUDF.findChild("lineEditFinalize", #LineEdit)

  ----------------------------------------
  -- Edit Dialog
  ----------------------------------------
  me.pDialogEdit = loader.load($.@("resources/edit.ui"), me.pMainWin)

  buttonBox = me.pDialogEdit.findChild("buttonBox", #DialogButtonBox)
  buttonBox.connect(#accepted, me, #slotDialogEditAccepted)

  me.pDialogEditPlainTextEditValue = me.pDialogEdit.findChild("plainTextEditValue", #PlainTextEdit)
  me.pDialogEditPlainTextEditValue.connect(#textChanged, me, #slotPlainTextEditValueChanged)

  me.pDialogEditCheckBoxNull = me.pDialogEdit.findChild("checkBoxNull", #CheckBox)
  me.pDialogEditCheckBoxNull.connect(#toggled, me, #slotCheckBoxNullToggled)

  ----------------------------------------
  -- Field Dialog
  ----------------------------------------
  me.pDialogField = loader.load($.@("resources/field.ui"), me.pMainWin)

  buttonBox = me.pDialogField.findChild("buttonBox", #DialogButtonBox)
  buttonBox.connect(#accepted, me, #slotDialogEditFieldAccepted)

  me.pDialogFieldLineEditName = me.pDialogField.findChild("lineEditName", #LineEdit)
  --me.pDialogFieldLineEditType = me.pDialogField.findChild("lineEditType", #LineEdit)
  me.pDialogFieldComboBoxType = me.pDialogField.findChild("comboBoxType", #ComboBox)
  me.pDialogFieldLineEditDefault = me.pDialogField.findChild("lineEditDefault", #LineEdit)
  me.pDialogFieldCheckBoxNotNull = me.pDialogField.findChild("checkBoxNotNull", #CheckBox)

  types = ["TEXT","INTEGER","REAL","BLOB","NUMERIC","INTEGER PRIMARY KEY"]
  repeat with t in types
    me.pDialogFieldComboBoxType.addItem(t)
  end repeat

  ----------------------------------------
  -- structure tab
  ----------------------------------------
  me.pTreeWidgetStructure = me.pMainWin.findChild("dbTreeWidget", #TreeWidget)

  me.pTreeWidgetStructure.setContextMenuPolicy($.Qt.CustomContextMenu)
  me.pTreeWidgetStructure.connect(#customContextMenuRequested, me, #slotStructureContextMenu)

  me.pTreeWidgetStructure.connect(#itemExpanded, me, #slotStructureItemExpanded)

  ----------------------------------------
  -- browse tab
  ----------------------------------------
  me.pTableWidgetBrowse = me.pMainWin.findChild("dataTable", #TableWidget)
  me.pTableWidgetBrowse.setVerticalDefaultSectionSize(18)
  me.pTableWidgetBrowse.setHorizontalHeaderDefaultAlignment($.Qt.AlignLeft)

  me.pTableWidgetBrowse.connect(#cellDoubleClicked, me, #slotCellDoubleClicked)


  me.pComboBoxBrowseTable = me.pMainWin.findChild("comboBrowseTable", #ComboBox)
  me.pComboBoxBrowseTable.connect(#currentIndexChanged, me, #slotTableChanged)

  me.pToolButtonRefresh = me.pMainWin.findChild("buttonRefresh", #ToolButton)
  me.pToolButtonRefresh.connect(#clicked, me, #slotToolButtonRefreshClicked)

  me.pPushButtonNewRecord = me.pMainWin.findChild("buttonNewRecord", #PushButton)
  me.pPushButtonNewRecord.connect(#clicked, me, #slotPushButtonNewRecordClicked)

  me.pPushButtonDeleteRecord = me.pMainWin.findChild("buttonDeleteRecord", #PushButton)
  me.pPushButtonDeleteRecord.connect(#clicked, me, #slotPushButtonDeleteClicked)

  me.pLabelRecordset = me.pMainWin.findChild("labelRecordset", #Label)

  me.pToolButtonBegin = me.pMainWin.findChild("buttonBegin", #ToolButton)
  me.pToolButtonBegin.connect(#clicked, me, #slotToolButtonBeginClicked)

  me.pToolButtonPrevious = me.pMainWin.findChild("buttonPrevious", #ToolButton)
  me.pToolButtonPrevious.connect(#clicked, me, #slotToolButtonPreviousClicked)

  me.pToolButtonNext = me.pMainWin.findChild("buttonNext", #ToolButton)
  me.pToolButtonNext.connect(#clicked, me, #slotToolButtonNextClicked)

  me.pToolButtonEnd = me.pMainWin.findChild("buttonEnd", #ToolButton)
  me.pToolButtonEnd.connect(#clicked, me, #slotToolButtonEndClicked)

  me.pPushButtonGoto = me.pMainWin.findChild("buttonGoto", #PushButton)
  me.pPushButtonGoto.connect(#clicked, me, #slotPushButtonGotoClicked)

  me.pLineEditGoto = me.pMainWin.findChild("editGoto", #LineEdit)

  ----------------------------------------
  -- execute SQL tab
  ----------------------------------------
  me.pPlainTextEditSQL = me.pMainWin.findChild("plainTextEditSQL", #PlainTextEdit)
  me.pPushButtonExecute = me.pMainWin.findChild("pushButtonExecute", #PushButton)
  me.pLineEditMessage = me.pMainWin.findChild("lineEditMessage", #LineEdit)

  me.pTableWidgetResults = me.pMainWin.findChild("tableWidgetResults", #TableWidget)
  me.pTableWidgetResults.setVerticalDefaultSectionSize(18)
  me.pTableWidgetResults.setHorizontalHeaderDefaultAlignment($.Qt.AlignLeft)

  me.pPushButtonExecute.connect(#clicked, me, #slotPushButtonExecuteClicked)

  ----------------------------------------
  -- setup actions
  ----------------------------------------
  me.pActions = [:]
  menuBar = me.pMainWin.findChild("menubar", #MenuBar)
  menus = menuBar.findChildren(VOID, #Menu)
  repeat with m in menus
    actions = m.actions()
    repeat with a in actions
      str = a.objectName()
      if str<>"" then me.pActions[str] = a
    end repeat
  end repeat

  -- File
  me.pActions.fileNewAction.connect(#triggered, me, #slotFileNew)
  me.pActions.fileOpenAction.connect(#triggered, me, #slotFileOpen)
  me.pActions.fileOpenReadOnlyAction.connect(#triggered, me, #slotFileOpenReadOnly)
  me.pActions.fileOpenMemoryAction.connect(#triggered, me, #slotFileOpenMemory)
  me.pActions.fileAttachAction.connect(#triggered, me, #slotFileAttach)
  me.pActions.fileAttachMemoryAction.connect(#triggered, me, #slotFileAttachMemory)
  me.pActions.fileCloseAction.connect(#triggered, me, #slotFileClose)
  me.pActions.actionEncryption.connect(#triggered, me, #slotEncryption)
  me.pActions.actionLoadExtension.connect(#triggered, me, #slotFileLoadExtension)
  me.pActions.fileExitAction.connect(#triggered, me, #slotExit)
  me.pActions.fileImportSQLAction.connect(#triggered, me, #slotDatabaseImportSQL)
  me.pActions.fileDefineUDFAction.connect(#triggered, me, #slotDefineUDF)

  -- View
  viewMenu = menuBar.findChild("viewMenu", #Menu)
  me.pActions.viewShowROWIDAction.connect(#toggled, me, #slotViewShowROWIDToggled)

  -- add encodings
  encodingMenu = $.Qt.Menu.new(me.pMainWin)
  encodingMenu.setTitle((("Text Encoding")))
  viewMenu.addMenu(encodingMenu)

  encodings = _system.getInstalledCharSets()

  -- UTF-8 as default
  encodings.deleteOne("utf-8")
  a = $.Qt.Action.new(viewMenu)
  a.setText("utf-8")
  a.setCheckable(TRUE)
  a.setChecked(TRUE)
  a.connect(#triggered, me, #slotViewEncodingChanged)
  me.pActiveEncodingAction = a
  encodingMenu.addAction(a)
  encodingMenu.addSeparator()

  -- add other encodings
  repeat with e in encodings
    a = $.Qt.Action.new(viewMenu)
    a.setCheckable(TRUE)
    a.setText(e)
    a.connect(#triggered, me, #slotViewEncodingChanged)
    encodingMenu.addAction(a)
  end repeat

  -- Help
  me.pActions.helpAboutAction.connect(#triggered, me, #slotHelpAbout)

  -- restore saved window state
  dataDir = $.PATH&"data\"
  me.pState = $.Qt.Settings.new($.Qt.QSettings.IniFormat, dataDir&"state.ini")

  val = me.pState.value("MainWindow/Geometry")
  ok = me.pMainWin.restoreGeometry(val)
  val = me.pState.value("MainWindow/State")
  ok = me.pMainWin.restoreState(val)

  -- check command line
  if $.RUNMODE="STANDALONE" and $.ARGS.count then me.openDbFile($.ARGS[1])

  me.pMainWin.show()
  return me
end

--------------------------------------
--
--------------------------------------
on updateUI (me, flag)
  -- update action states
  me.pActions.fileAttachAction.setEnabled(flag)
  me.pActions.fileAttachMemoryAction.setEnabled(flag)
  me.pActions.fileCloseAction.setEnabled(flag)
  me.pActions.actionLoadExtension.setEnabled(flag)
  me.pActions.fileDefineUDFAction.setEnabled(flag)

  -- update widgets
  me.pToolButtonRefresh.setDisabled(not flag)
  me.pPushButtonNewRecord.setDisabled(not flag)
  me.pPushButtonDeleteRecord.setDisabled(not flag)
  me.pPushButtonExecute.setDisabled(not flag)
  me.pPushButtonGoto.setDisabled(not flag)
end

----------------------------------------
--
----------------------------------------
on openDbFile (me, fn, readOnly)
  me.slotFileClose()

  ok = me.pSX.sqlite_open(fn, me.pErr, readOnly)
  if not ok then
    me.err(me.pErr[1])
    return FALSE
  end if

  if me.pPassphrase<>"" then
    sql = "PRAGMA key=#"
    ok = me.pSX.sqlite_exec(sql, [me.pPassphrase], me.pErr)
  end if

  -- ok doesn't mean anything, SQLite "opens" arbitrary files.
  -- So check if it's really a (compatible) SQLite file
  sql = "pragma schema_version"
  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if not ok then
    -- "file is encrypted or is not a database"
    me.err(me.pErr[1])
    return FALSE
  end if

  me.pDatabases["main"] = fn

  me.pMainWin.setWindowTitle(me.pAppName &" - "&fn)

  me.updateUI(TRUE)
  me.showDbStructure()
  return TRUE
end

----------------------------------------
-- reloads all open databases
-- updates pTreeWidgetStructure, pTableInfo and pComboBoxBrowseTable
----------------------------------------
on showDbStructure (me)

  me.clearItem(me.pTreeWidgetStructure.invisibleRootItem())
  me.pComboBoxBrowseTable.clear()

  me.pTableInfo = [:]

  cnt = me.pDatabases.count
  repeat with i = 1 to cnt
    dbName = me.pDatabases.getPropAt(i)
    dbFile = me.pDatabases[i]
    me.addDB(dbName, dbFile)
  end repeat
end

----------------------------------------
-- adds database to pTreeWidgetStructure, pTableInfo and pComboBoxBrowseTable
----------------------------------------
on addDB (me, dbName, dbFile)

  -- create a db item
  dbItem = $.Qt.TreeWidgetItem.new()
  dbItem.setData(0, $.Qt.UserRole, "database")
  dbItem.setIcon(0, ":/icons/database")
  dbItem.setText(0, dbName)
  dbItem.setToolTip(0, dbFile)

  me.pTreeWidgetStructure.addTopLevelItem(dbItem)

  me.pTableInfo[dbName] = [:]
  me.pTableInfo[dbName].sort()

  ----------------------------------------
  -- tables
  ----------------------------------------
  tablesItem = $.Qt.TreeWidgetItem.new()

  tablesItem.setIcon(0, ":/icons/table")
  tablesItem.setData(0, $.Qt.UserRole, "tables")
  treeItems = []
  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='table' ORDER BY name COLLATE NOCASE"
  tables = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)
  repeat with row in tables
    tableName = row[#name]

    treeItem = $.Qt.TreeWidgetItem.new()
    treeItem.setData(0, $.Qt.UserRole, "table")
    treeItem.setIcon(0, ":/icons/table")
    treeItem.setText(0, tableName)
    treeItem.setText(1, row[#type])

    schema = row[#sql]
    schema = $.regex.replace("[\r\n\t ]+", " ", schema, "g")
    treeItem.setText(3, schema)

    -- test
    sql = "PRAGMA "&dbName&".TABLE_INFO('"&tableName&"')"
    fields = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)
    me.pTableInfo[dbName][tableName] = fields

    childItems = []
    repeat with f in fields
      childItem = $.Qt.TreeWidgetItem.new()
      childItem.setIcon(0, ":/icons/field")
      childItem.setData(0, $.Qt.UserRole, "field")
      childItem.setText(0, f[#name])
      childItem.setText(1, "field")
      childItem.setText(2, f[#type])

      str = "`"&f[#name]&"`"&&f[#type]
      if f[#pk] then put " PRIMARY KEY" after str
      if f[#notnull] then put " NOT NULL" after str
      if not voidP(f[#dflt_value]) then
        put " DEFAULT "&f[#dflt_value] after str
      end if
      childItem.setText(3, str)

      childItems.add(childItem)
    end repeat
    treeItem.addChildren(childItems)
    treeItems.add(treeItem)

    me.pComboBoxBrowseTable.addItem(dbName&"."&tableName)
  end repeat

  tablesItem.addChildren(treeItems)
  tablesItem.setText(0, "Tables ("&tables.count&")")

  dbItem.addChild(tablesItem)

  ----------------------------------------
  -- indexes
  ----------------------------------------
  indexesItem = $.Qt.TreeWidgetItem.new()
  indexesItem.setData(0, $.Qt.UserRole, "indexes")
  indexesItem.setIcon(0, ":/icons/index")
  treeItems = []
  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='index' ORDER BY name COLLATE NOCASE"
  indexes = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)
  repeat with row in indexes
    treeItem = $.Qt.TreeWidgetItem.new()
    treeItem.setData(0, $.Qt.UserRole, "index")
    treeItem.setIcon(0, ":/icons/index")
    treeItem.setText(0, row[#name])
    treeItem.setText(1, row[#type])
    schema = row[#sql]
    if not voidP(schema) then
      schema = $.regex.replace("[\r\n\t ]+", " ", schema, "g")
      treeItem.setText(3, schema)
    end if
    treeItems.add(treeItem)
  end repeat

  indexesItem.addChildren(treeItems)
  indexesItem.setText(0, "Indexes ("&indexes.count&")")

  dbItem.addChild(indexesItem)

  ----------------------------------------
  -- views
  ----------------------------------------
  viewsItem = $.Qt.TreeWidgetItem.new()
  viewsItem.setData(0, $.Qt.UserRole, "views")
  viewsItem.setIcon(0, ":/icons/view")
  treeItems = []
  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='view' ORDER BY name COLLATE NOCASE"
  views = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)
  repeat with row in views
    viewName = row[#name]
    treeItem = $.Qt.TreeWidgetItem.new()
    treeItem.setData(0, $.Qt.UserRole, "view")
    treeItem.setIcon(0, ":/icons/view")
    treeItem.setText(0, viewName)
    treeItem.setText(1, row[#type])
    schema = row[#sql]
    schema = $.regex.replace("[\r\n\t ]+", " ", schema, "g")
    treeItem.setText(3, schema)
    treeItems.add(treeItem)
  end repeat

  viewsItem.addChildren(treeItems)
  viewsItem.setText(0, "Views ("&views.count&")")

  dbItem.addChild(viewsItem)

  ----------------------------------------
  -- triggers
  ----------------------------------------
  triggersItem = $.Qt.TreeWidgetItem.new()
  triggersItem.setData(0, $.Qt.UserRole, "triggers")
  triggersItem.setIcon(0, ":/icons/trigger")
  treeItems = []
  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='trigger' ORDER BY name COLLATE NOCASE"
  triggers = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)
  repeat with row in triggers
    treeItem = $.Qt.TreeWidgetItem.new()
    treeItem.setData(0, $.Qt.UserRole, "trigger")
    treeItem.setIcon(0, ":/icons/trigger")
    treeItem.setText(0, row[#name])
    treeItem.setText(1, row[#type])
    schema = row[#sql]
    schema = $.regex.replace("[\r\n\t ]+", " ", schema, "g")
    treeItem.setText(3, schema)
    treeItems.add(treeItem)
  end repeat

  triggersItem.addChildren(treeItems)
  triggersItem.setText(0, "Triggers ("&triggers.count&")")

  dbItem.addChild(triggersItem)
  tablesItem.setExpanded(TRUE)
  dbItem.setExpanded(TRUE)
end

----------------------------------------
--
----------------------------------------
on showTable (me, tableNameFull, rowOffset, rowSelected)

  _player.itemDelimiter = "."
  dbName = tableNameFull.item[1]
  tableName = tableNameFull.item[2]

  if voidP(rowOffset) then rowOffset=0

  -- reset
  me.pTableWidgetBrowse.setColumnCount(0)
  me.pTableWidgetBrowse.setRowCount(0)

  -- get fields
  info = me.pTableInfo[dbName][tableName]
  --put info

  if me.pShowROWID then
    info = info.duplicate()
    info.addAt(1, [#name:"ROWID", #type:"INTEGER"])
  end if

  fields = []
  repeat with f in info
    fields.add(f[#name])
  end repeat
  colCnt = fields.count

  me.pTableWidgetBrowse.setColumnCount(colCnt)
  me.pTableWidgetBrowse.setHorizontalHeaderLabels(fields)

  -- get totalCnt
  sql = "SELECT COUNT(*) FROM "&tableNameFull
  res = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)
  totalCnt = res[1][1]

  if rowOffset<0 then rowOffset = totalCnt+rowOffset
  rowOffset = min(totalCnt-1 - me.pBrowseRowsPerPage, rowOffset)
  rowOffset = max(0, rowOffset)

  me.pCurrentRowOffset = rowOffset

  -- get data
  sql = "SELECT ROWID AS ROWID,* FROM "&tableNameFull&" LIMIT "&rowOffset&","&me.pBrowseRowsPerPage
  res = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)

  rowCnt = res.count

  me.pTableWidgetBrowse.setRowCount(rowCnt)

  repeat with row = 1 to rowCnt

    ROWID = res[row][#ROWID]

    if not me.pShowROWID then res[row].deleteProp(#ROWID)

    repeat with col = 1 to colCnt
      tableItem = $.Qt.TableWidgetItem.new()

      val = res[row][col]

      dataType = ilk(val)
      case dataType of

        #void:
          str = "NULL"
          tableItem.setForeground(rgb(128,128,128))

        #string:
          if info[col][#type]="BLOB" then

            -- save BLOB data as bytearray in cell
            ba = sqlite_binary_string_to_bytearray(val)
            tableItem.setData($.Qt.UserRole+2, ba)

            str = "<BLOB>"
            dataType = #bytearray

          else
            str = val
            -- convert to UTF-8
            if me.pEncoding<>"utf-8" then
              ba = sqlite_binary_string_to_bytearray(str)
              if ba.length then
                str = ba.readRawString(ba.length, me.pEncoding)
              end if
            end if
          end if

        otherwise:
          str = string(val)
        end case

      tableItem.setText(str)
      tableItem.setData($.Qt.UserRole, ROWID)

       -- save data type
      tableItem.setData($.Qt.UserRole+1, string(dataType))

      me.pTableWidgetBrowse.setItem(row-1, col-1, tableItem)
    end repeat
  end repeat

  -- update row number display
  str = (1+rowOffset)&" - "&(rowCnt+rowOffset)&" of "&totalCnt
  me.pLabelRecordset.setText(str)

  -- always select first row by default
  if voidP(rowSelected) then rowSelected=0
  if rowSelected=-1 then rowSelected=rowCnt-1
  if rowCnt>rowSelected then me.pTableWidgetBrowse.setCurrentCell(rowSelected, 0)

  -- update toolbutton states
  me.pToolButtonBegin.setDisabled(rowOffset=0)
  me.pToolButtonPrevious.setDisabled(rowOffset=0)
  me.pToolButtonNext.setDisabled(rowOffset+rowCnt>=totalCnt)
  me.pToolButtonEnd.setDisabled(rowOffset+rowCnt>=totalCnt)
end

----------------------------------------
--
----------------------------------------
on clearItem (me, treeWidgetItem)
  childItems = treeWidgetItem.takeChildren()
  repeat with childItem in childItems
    if childItem.childCount() then me.clearItem(childItem)
    childItem.destroy()
  end repeat
end

----------------------------------------
-- Helper for InputDialog.getText dialogs with translated standard buttons
----------------------------------------
on getText (me, caption, label, echoMode, txt)
  d = $.Qt.InputDialog.new(me.pMainWin)
  d.setWindowTitle(caption)
  d.setLabelText(label)
  --d.resize(400, 0)
  if not voidP(echoMode) then d.setTextEchoMode(echoMode)
  if not voidP(txt) then d.setValue(txt)
  d.setCancelButtonText((("Cancel")))
  ok = d.exec()
  res = d.value()
  d.destroy()
  if ok then return res
end

----------------------------------------
-- Shows status info in status bar
----------------------------------------
on stat (me, str)
  me.pStatusBar.showMessage(str)--, 5000)
  me.pPlainTextEditLog.appendPlainText("Status>   "&str)
end

----------------------------------------
-- Shows error message in status bar
----------------------------------------
on err (me, str)
  me.pStatusBar.showMessage((("Error"))&":"&&str)
  me.pPlainTextEditLog.appendPlainText("Error>    "&str)
end

----------------------------------------
--
----------------------------------------
on hexToBytes (me, str)
  ba = bytearray()
  cnt = str.word.count
  repeat with i = 1 to cnt
    ba[i] = rgb(str.word[i]).blue
  end repeat
  return ba
end

----------------------------------------
-- called when fields are added, changed or dropped
----------------------------------------
on updateTableInfo (me, tableName, tableItem, dbName)

  -- update schema in structure tab
  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='table' AND name='"&tableName&"'"
  res = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)
  row = res[1]
  schema = row[#sql]
  schema = $.regex.replace("[\r\n\t ]+", " ", schema, "g")
  tableItem.setText(3, schema)

  -- update pTableInfo
  sql = "PRAGMA "&dbName&".TABLE_INFO('"&tableName&"')"
  fields = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)
  me.pTableInfo[dbName][tableName] = fields

  -- update browse table?
  tableNameFull = dbName&"."&tableName
  if me.pComboBoxBrowseTable.currentText()=tableNameFull then
    me.showTable(tableNameFull)
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on updateComboBoxBrowseTable (me)
  me.pComboBoxBrowseTable.clear()
  dbCnt =  me.pTableInfo.count
  repeat with i = 1 to dbCnt
    db = me.pTableInfo.getPropAt(i)
    tableCnt = me.pTableInfo[i].count
    repeat with j = 1 to tableCnt
      me.pComboBoxBrowseTable.addItem(db&"."&me.pTableInfo[i].getPropAt(j))
    end repeat
  end repeat
end

-- marker for faster navigation in code editor
on __SLOTS
end

----------------------------------------
-- @callback
----------------------------------------
on slotFileNew (me)
  dir = $.PATH
  filter = "SQLite Files (*.db *.sqlite)"
  fn = $.Qt.FileDialog.getSaveFileName(me.pMainWin, (("New File...")), dir, filter)
  if string(fn)="" then return
  me.openDbFile($.@(fn))
end

----------------------------------------
-- @callback
----------------------------------------
on slotFileOpen (me)
  dir = $.PATH
  filter = "SQLite Files (*.db *.sqlite)"
  fn = $.Qt.FileDialog.getOpenFileName(me.pMainWin, (("Open File...")), dir, filter)
  if string(fn)="" then return
  me.openDbFile($.@(fn))
end

----------------------------------------
-- @callback
----------------------------------------
on slotFileOpenReadOnly (me)
  dir = $.PATH
  filter = "SQLite Files (*.db *.sqlite)"
  fn = $.Qt.FileDialog.getOpenFileName(me.pMainWin, (("Open File...")), dir, filter)
  if string(fn)="" then return
  me.openDbFile($.@(fn), TRUE)
end

----------------------------------------
-- @callback
----------------------------------------
on slotFileOpenMemory (me)
  me.openDbFile(":memory:")
end

----------------------------------------
-- @callback
----------------------------------------
on slotDatabaseCompact (me)
  sql = "VACUUM"
  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if ok then
    me.stat((("Database successfully compacted")))
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotEncryption (me)
  me.pPassphrase = me.getText((("Encryption...")), (("Enter passphrase (empty string for no encryption)"))&":", 0, me.pPassphrase)
end

----------------------------------------
-- @callback
----------------------------------------
on slotFileLoadExtension (me)
  dir = $.PATH
  filter = "Loadable Extensions (*.dll)"
  fn = $.Qt.FileDialog.getOpenFileName(me.pMainWin, (("Select Loadable Extension...")), dir, filter)
  if string(fn)="" then return

  sql = "SELECT load_extension(#)"
  ok = me.pSX.sqlite_exec(sql, [$.@(fn)], me.pErr)

  -- or
  --ok = me.pSX.sqlite_load_extension(fn)

  if ok then
    me.stat((("Extension successfully loaded")))
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotFileAttach (me)

  -- use custom dialog that also supports non-existing file (=created on the fly)
  d = $.Qt.FileDialog.new(me.pMainWin)
  d.setDirectory($.PATH)
  d.setNameFilters(["SQLite Files (*.db *.sqlite)", "All Files (*.*)"])
  d.setDefaultSuffix("db")
  d.setWindowTitle((("Open File...")))
  ok = d.exec()
  if not ok then return
  res = d.selectedFiles()
  if res.count=0 then return
  fn = res[1]
  if fn="" then return
  fn = $.@(fn)

  dbName =string(me.getText("Access attached database as ...", "Database name:", 0, $.file.getBaseName(fn)))
  dbName = $.string.trim(dbName)
  if dbName="" then return

  sql = "ATTACH # AS #"
  ok = me.pSX.sqlite_exec(sql, [fn, dbName], me.pErr)
  if ok then
    me.stat((("Database successfully attached as"))&&"'"&dbName&"'")

    me.pDatabases[dbName] = fn

    -- add to structure tree
    me.addDB(dbName, fn)
  else
    me.err(me.pErr[1])
  end if
end

on slotFileAttachMemory (me)
  dbName =string(me.getText("Access attached database as ...", "Database name:", 0,"memory"))
  dbName = $.string.trim(dbName)
  if dbName="" then return

  fn = ":memory:"

  sql = "ATTACH # AS #"
  ok = me.pSX.sqlite_exec(sql, [fn, dbName], me.pErr)
  if ok then
    me.stat((("Database successfully attached as"))&&"'"&dbName&"'")

    me.pDatabases[dbName] = fn

    -- add to structure tree
    me.addDB(dbName, fn)
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotDetach (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.text(0)

  sql = "DETACH DATABASE #"
  ok = me.pSX.sqlite_exec(sql, [dbName], me.pErr)
  if ok then
    me.stat((("Database successfully detached")))

    me.pDatabases.deleteProp(dbName)

    -- remove from structure tree
    root = me.pTreeWidgetStructure.invisibleRootItem()
    index = root.indexOfChild(currItem)
    me.clearItem(currItem)
    childItem = root.takeChild(index)
    childItem.destroy()

    me.pTableInfo.deleteProp(dbName)
    me.updateComboBoxBrowseTable()

  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotFileClose (me)
  me.pSX.sqlite_close()
  me.pDatabases = [:]
  me.pMainWin.setWindowTitle(me.pAppName)
  me.updateUI(FALSE)

  -- empty structure
  me.clearItem(me.pTreeWidgetStructure.invisibleRootItem())

  -- empty browse
  me.pTableWidgetBrowse.setRowCount(0)
  me.pTableWidgetBrowse.setColumnCount(0)

  me.pComboBoxBrowseTable.clear()
end

----------------------------------------
-- @callback
----------------------------------------
on slotExit (me)

  me.slotFileClose()

  -- save state
  val = me.pMainWin.saveGeometry() -- bytearray
  me.pState.setValue("MainWindow/Geometry", val)
  val = me.pMainWin.saveState() -- bytearray
  me.pState.setValue("MainWindow/State", val)

  _movie.halt()
end

----------------------------------------
-- @callback
----------------------------------------
on slotHelpAbout (me)
  msg = "<b>"&me.pAppName&" v0."&me.pAppVersion&"</b><br>(c) 2017 Valentin Schmidt<br><br>"&\
  (("A simple SQLite Database Browser/Editor based on Lingo, Qt 4.8.6, SQLite 3.8.0.2 and SQLCipher.<br><br>UI loosely based on/stolen from open source software <a href='https://github.com/sqlitebrowser'>DB Browser for SQLite</a>."))

  $.Qt.MessageBox.about(me.pMainWin, (("About"))&&me.pAppName, msg)
end

----------------------------------------
-- @callback
----------------------------------------
on slotDrop (me, args)

  dropData = args[1]
  dropPoint = args[2]
  listWidget = args[3]
  data = args[1]
  if ilk(dropData)<>#list then return

  repeat with fn in dropData
    if $.filesystem.fileExists(fn) then
      me.openDbFile(fn)
      exit repeat
    end if
  end repeat
end

----------------------------------------
-- @callback
----------------------------------------
on slotDatabaseImportSQL (me)

  dir = $.PATH
  filter = "SQL Files (*.sql *.txt);;All Files (*.*)"
  fnSQL = $.Qt.FileDialog.getOpenFileName(me.pMainWin, (("Open File...")), dir, filter)
  if string(fnSQL)="" then return
  fnSQL = $.@(fnSQL)

  dir = $.file.getFilePath(fnSQL)&"\"&$.file.getBaseName(fnSQL)&".db"

  filter = "SQLite Files (*.db *.sqlite)"
  fnDB = $.Qt.FileDialog.getSaveFileName(me.pMainWin, (("Save SQLite File...")), dir, filter)
  if string(fnDB)="" then return
  fnDB = $.@(fnDB)

  ok = me.openDbFile(fnDB)
  if not ok then return

  sql = $.file.getString(fnSQL)
  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if ok then
    me.stat((("SQL file successfully imported")))
    me.showDbStructure()
  else
    me.err(me.pErr[1])
    me.slotFileClose()
    $.file.delete(fnDB)
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableImportCSV (me)
  dir = $.PATH
  filter = "CSV Files (*.csv *.txt);;All Files (*.*)"
  fn = $.Qt.FileDialog.getOpenFileName(me.pMainWin, (("Open File...")), dir, filter)
  if string(fn)="" then return
  fn = $.@(fn)

  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.parent().text(0)

  str = $.file.getString(fn)
  data = $.csv.parse(str, me.pCsvDelim, me.pCsvEOL, me.pCsvEnclosure)

  rowCnt = data.count
  if rowCnt=0 then
    me.err((("Error parsing CSV file")))
    return
  end if

  sql = "BEGIN TRANSACTION;"

  -- use first line as table def (type=TEXT)
  tableName = $.file.getBaseName(fn)
  row = data[1]
  put "CREATE TABLE "&dbName&"."&tableName&"(" after sql
  repeat with f in row
    put "`"&f&"`" && "TEXT," after sql
  end repeat
  delete the last char of sql
  put ");" after sql

  -- import data
  repeat with i = 2 to rowCnt
    row = data[i]
    put "INSERT INTO "&dbName&"."&tableName&" VALUES(" after sql
    tmp = ""
    repeat with f in row
      put "'" & sqlite_escape_string(f) & "'," after tmp
    end repeat
    delete the last char of tmp
    put tmp after sql
    put ");" after sql
  end repeat

  put "COMMIT;" after sql

  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if ok then
    me.stat((("Table successfully imported")))
    me.showDbStructure()
  else
    me.err(me.pErr[1])
    me.pSX.sqlite_exec("ROLLBACK;")
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableImportJSON (me)
  dir = $.PATH
  filter = "JSON Files (*.json);;All Files (*.*)"
  fn = $.Qt.FileDialog.getOpenFileName(me.pMainWin, (("Open File...")), dir, filter)
  if string(fn)="" then return
  fn = $.@(fn)

  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.parent().text(0)

  -- get file contents
  str = $.file.getString(fn)

  -- decode
  data = $.json.decode(str)

  if voidP(data) then
    me.err("Could not parse JSON file")
    return
  else if data.count=0 then
    me.err("No data found in JSON file")
    return
  end if

  sql = "BEGIN TRANSACTION;"

  tableName = $.file.getBaseName(fn)
  row = data[1]
  put "CREATE TABLE "&dbName&"."&tableName&"(" after sql

  -- use first row as table def
  firstRow = data[1]
  cnt = firstRow.count
  repeat with i = 1 to cnt
    f = firstRow.getPropAt(i)
    v = firstRow[i]

    if integerP(v) then
      dataType = "INTEGER"
    else if floatP(v) then
      dataType = "REAL"
    else
      dataType = "TEXT"
    end if

    put "`"&f&"`" && dataType &"," after sql
  end repeat
  delete the last char of sql
  put ");" after sql

  -- import data
  rowCnt = data.count
  repeat with i = 1 to rowCnt
    row = data[i]
    put "INSERT INTO "&dbName&"."&tableName&" VALUES(" after sql
    tmp = ""
    repeat with f in row
      if stringP(f) then f = sqlite_escape_string(f)
      put "'" & f & "'," after tmp
    end repeat
    delete the last char of tmp
    put tmp after sql
    put ");" after sql
  end repeat

  put "COMMIT;" after sql

  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if ok then
    me.stat((("Table successfully imported")))
    me.showDbStructure()
  else
    me.err(me.pErr[1])
    me.pSX.sqlite_exec("ROLLBACK;")
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotDatabaseExportSQL (me)
  dir = $.PATH
  filter = "SQL Files (*.sql *.txt);;All Files (*.*)"
  fn = $.Qt.FileDialog.getSaveFileName(me.pMainWin, (("Save SQL Dump as...")), dir, filter)
  if fn="" then return

  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.text(0)

  -- get all tables
  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='table'"
  tables = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)
  if voidP(tables) then
    me.err(me.pErr[1])
    return
  end if

  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='index'"
  indexes = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)
  if voidP(indexes) then
    me.err(me.pErr[1])
    return
  end if

  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='view'"
  views = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)
  if voidP(views) then
    me.err(me.pErr[1])
    return
  end if

  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='trigger'"
  triggers = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)
  if voidP(triggers) then
    me.err(me.pErr[1])
    return
  end if

  fp = $.file.fopen($.@(fn), "w")
  if fp=FALSE then
    me.err("File could not be created")
    return
  end if

  $.file.fwritestring(fp, "BEGIN TRANSACTION;"&me.pSqlExportEOL)

  repeat with table in tables
    -- CREATE PART
    $.file.fwritestring(fp, table["sql"]&";"&me.pSqlExportEOL)

    -- INSERT PART
    sql = "SELECT * FROM "&dbName&"."&table["tbl_name"]
    data = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)
    if voidP(data) then
      me.err(me.pErr[1])
      $.file.fclose(fp)
      $.file.delete(fn)
      return
    end if

    repeat with row in data
      columnValue = [:]
      if me.pSqlExportFullInserts then columnList = []
      cnt = row.count
      repeat with i = 1 to cnt
        columnValue[row.getPropAt(i)] = "'"&sqlite_escape_string(string(row[i]))&"'"
        if me.pSqlExportFullInserts then
          columnList.add(string(row.getPropAt(i)))
        end if
      end repeat
      $.file.fwritestring(fp, "INSERT INTO "&table["tbl_name"])
      if me.pSqlExportFullInserts then
        $.file.fwritestring(fp, " ("&$.string.implode(", ", columnList)&")") -- FOR FULL INSERTS
      end if
      $.file.fwritestring(fp, " VALUES ("&$.string.implode(", ", columnValue)&");" & me.pSqlExportEOL)
    end repeat
  end repeat

  -- add indexes
  repeat with index in indexes
    $.file.fwritestring(fp, index[#sql]&";" & me.pSqlExportEOL)
  end repeat

  -- add views
  repeat with view in views
    $.file.fwritestring(fp, view[#sql]&";" & me.pSqlExportEOL)
  end repeat

  -- add triggers
  repeat with trigger in triggers
    $.file.fwritestring(fp, trigger[#sql]&";" & me.pSqlExportEOL)
  end repeat

  $.file.fwritestring(fp, "COMMIT;"&me.pSqlExportEOL)
  $.file.fclose(fp)
  me.stat("Database successfully exported")
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableChanged (me, widget, index)
  tableNameFull = me.pComboBoxBrowseTable.itemText(index)
  if tableNameFull="" then return
  me.showTable(tableNameFull, 0)
end

----------------------------------------
-- @callback
----------------------------------------
on slotCellDoubleClicked (me, widget, row, col)
  currItem = me.pTableWidgetBrowse.item_(row, col)

  -- check if field allows NULL
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  _player.itemDelimiter = "."
  dbName = tableNameFull.item[1]
  tableName = tableNameFull.item[2]

  if me.pShowROWID and col=0 then
    notnull = TRUE
  else
    if not me.pShowROWID then col=col+1
    notnull = me.pTableInfo[dbName][tableName][col][#notnull]
  end if

  me.pDialogEditCheckBoxNull.setDisabled(notnull)

  dataType = currItem.data($.Qt.UserRole+1)
  if dataType="void" then
    me.pDialogEditCheckBoxNull.setChecked(TRUE)
    str = ""

  else if dataType="bytearray" then
    ba = currItem.data($.Qt.UserRole+2)
    str = ba.tohexString(1, ba.length)

  else
    me.pDialogEditCheckBoxNull.setChecked(FALSE)
    str = currItem.text()
  end if

  me.pDialogEditPlainTextEditValue.setPlainText(str)

  me.pDialogEdit.setProp(#item, currItem)
  me.pDialogEdit.open()
end

----------------------------------------
-- @callback
----------------------------------------
on slotViewEncodingChanged (me, action)

  -- uncheck previous encoding
  me.pActiveEncodingAction.setChecked(FALSE)

  -- update pEncoding
  me.pEncoding = action.text()
  me.pActiveEncodingAction = action

  -- update browse table
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  if tableNameFull<>"" then
    rowOffset = me.pCurrentRowOffset
    rowSelected = me.pTableWidgetBrowse.currentItem().row()
    me.showTable(tableNameFull, rowOffset, rowSelected)
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotToolButtonRefreshClicked (me)
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  rowOffset = me.pCurrentRowOffset
  me.showTable(tableNameFull, rowOffset)
end

----------------------------------------
-- @callback
----------------------------------------
on slotPushButtonNewRecordClicked (me)
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  if tableNameFull="" then return

  _player.itemDelimiter = "."
  dbName = tableNameFull.item[1]
  tableName = tableNameFull.item[2]

  info = me.pTableInfo[dbName][tableName]
  --put tableName, info

  tableStr = ""
  valueStr = ""
  repeat with f in info
    if f[#notnull] and voidP(f[#dflt_value]) and not(f[#pk]) then
      put f[#name]&"," after tableStr
      put "''," after valueStr
    end if
  end repeat
  delete the last char of tableStr
  delete the last char of valueStr

  if tableStr="" then
    sql = "INSERT INTO "&tableName&" DEFAULT VALUES"
  else
    sql = "INSERT INTO "&tableName&"("&tableStr&") VALUES("&valueStr&")"
  end if
  --put sql

  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if ok then
    me.stat((("Record successfully added")))
    me.showTable(tableNameFull, -me.pBrowseRowsPerPage, -1)
    me.pTableWidgetBrowse.scrollToBottom()
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotPushButtonDeleteClicked (me)
  if me.pTableWidgetBrowse.rowCount()=0 then return

  currItem = me.pTableWidgetBrowse.currentItem()
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  ROWID = currItem.data($.Qt.UserRole)
  sql = "DELETE FROM "&tableNameFull&" WHERE ROWID="&ROWID
  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if ok then
    me.stat((("Record successfully deleted")))
    me.pTableWidgetBrowse.removeRow(currItem.row())
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotToolButtonBeginClicked (me)
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  rowOffset = 0
  me.showTable(tableNameFull, rowOffset)
end

----------------------------------------
-- @callback
----------------------------------------
on slotToolButtonPreviousClicked (me)
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  rowOffset = max(me.pCurrentRowOffset - me.pBrowseRowsPerPage, 0)
  me.showTable(tableNameFull, rowOffset)
end

----------------------------------------
-- @callback
----------------------------------------
on slotToolButtonNextClicked (me)
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  rowOffset = me.pCurrentRowOffset + me.pBrowseRowsPerPage
  me.showTable(tableNameFull, rowOffset)
end

----------------------------------------
-- @callback
----------------------------------------
on slotToolButtonEndClicked (me)
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  rowOffset = - me.pBrowseRowsPerPage
  me.showTable(tableNameFull, rowOffset)
end

----------------------------------------
-- @callback
----------------------------------------
on slotPushButtonGotoClicked (me)
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  rowOffset = integer(me.pLineEditGoto.text())-1
  me.showTable(tableNameFull, rowOffset)
end

----------------------------------------
-- @callback
----------------------------------------
on slotDefineUDF (me)
  me.pDialogUDF.open()
end

----------------------------------------
-- @callback
----------------------------------------
on slotDialogUDFAccepted (me, widget)

  functionName = me.pDialogUDF.findChild("lineEditFunctionName", #LineEdit).text()
  if functionName="" then
    alert((("You have to specify a function name")))
    return
  end if

  lingoCode = me.pDialogUDF.findChild("plainTextEditLingoCode", #PlainTextEdit).toPlainText()
  if lingoCode="" then
    alert((("You have to specify the UDF's Lingo code")))
    return
  end if
  -- convert LF to CR
  lingoCode = $.string.replace($.LF, $.CR, lingoCode)

  numArgs = integer(me.pDialogUDF.findChild("spinBoxNumArgs", #SpinBox).value())

  -- assign temporary alertHook to capture invalid Lingo code
  _player.alertHook = me

  -- try to create a new Lingo movie script
  m = new(#script)
  m.scriptText = lingoCode

  -- remove temporary alertHook
  _player.alertHook = 0

  if not voidP(me.pLingoCompileError) then
    me.err(me.pLingoCompileError)
    me.pLingoCompileError = VOID
    return
  end if

  -- add the UDF
  isAggregate = me.pCheckBoxAggregate.isChecked()
  if isAggregate then
    finalizeFuncName= $.string.trim(me.pLineEditFinalize.text())
    if finalizeFuncName<>"" then
      ok = me.pSX.sqlite_create_aggregate(functionName, numArgs, finalizeFuncName)
    else
      ok = me.pSX.sqlite_create_aggregate(functionName, numArgs)
    end if
  else
    ok = me.pSX.sqlite_create_function(functionName, numArgs)
  end if

  if ok then
    me.stat((("UDF '"&functionName&"' successfully created")))
  else
    me.err((("Creating UDF failed")))
  end if

  -- close the dialog
  me.pDialogUDF.close()
end

----------------------------------------
-- alerthook for capturing compile errors of user-defined Lingo code
----------------------------------------
on alertHook (me, aMsg, aText, aType)
  case (aType) of
    #alert: return 0
    otherwise:
      me.pLingoCompileError = aMsg&" - "&aText
      _player.alertHook = 0 -- ???
      return 1
  end case
end

----------------------------------------
-- @callback
----------------------------------------
on slotPushButtonExecuteClicked (me)

  sql = me.pPlainTextEditSQL.toPlainText()
  res = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)

  me.pLineEditMessage.setText(me.pErr[1])

  if voidP(res) then rowCnt=0
  else rowCnt = res.count

  -- reset
  me.pTableWidgetResults.setColumnCount(0)
  me.pTableWidgetResults.setRowCount(0)

  if rowCnt then
    columnCnt = res[1].count
    me.pTableWidgetResults.setColumnCount(columnCnt)

    labels = []
    repeat with i = 1 to columnCnt
      labels.add(string(res[1].getPropAt(i)))
    end repeat
    me.pTableWidgetResults.setHorizontalHeaderLabels(labels)

    -- todo: paging?
    if rowCnt>me.pExecuteMaxRows then
      me.stat("The Query returned "&rowCnt&" rows, but only "&me.pExecuteMaxRows&" are shown. Either use LIMIT in your query, or change the MaxRows value in settings.ini")
      rowCnt = me.pExecuteMaxRows
    end if

    me.pTableWidgetResults.setRowCount(rowCnt)
    repeat with row = 1 to rowCnt
      repeat with col = 1 to columnCnt
        tableItem = $.Qt.TableWidgetItem.new()

        val = res[row][col]
        case ilk(val) of

        #void:
          str = "NULL"
          tableItem.setForeground(rgb(128,128,128))

        #string:
          -- @TODO: make SQLite xtra return bytearray in case of BLOB data!

--          if info[col][#type]="BLOB" then
--            -- save BLOB data as bytearray in cell
--            ba = sqlite_binary_string_to_bytearray(val)
--            tableItem.setData($.Qt.UserRole+2, ba)
--            str = "<BLOB>"
--            dataType = #bytearray

--          else

          str = val

          -- convert to UTF-8
          if me.pEncoding<>"utf-8" then
            ba = sqlite_binary_string_to_bytearray(str)
            if ba.length then
              str = ba.readRawString(ba.length, me.pEncoding)
            end if
          end if

--          end if

        otherwise:
          str = string(val)

        end case

        tableItem.setText(str)
        me.pTableWidgetResults.setItem(row-1, col-1, tableItem)

      end repeat
    end repeat
  end if

  -- always reload structure tab -> triggers also reload of browse tab
  me.showDbStructure()
end

----------------------------------------
-- @callback
----------------------------------------
on slotCheckBoxAggregateToggled (me, widget, flag)
  me.pLabelFinalize.setDisabled(not flag)
  me.pLineEditFinalize.setDisabled(not flag)
end

----------------------------------------
-- @callback
----------------------------------------
on slotStructureContextMenu (me, widget, p)
  currItem = me.pTreeWidgetStructure.currentItem()
  if currItem=0 then return

  -- check item type
  itemType = currItem.data(0, $.Qt.UserRole)

  case itemType of
  "database":
    isMain = (currItem.text(0)="main")
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setText((("Compact Database")))
    action.connect(#triggered, me, #slotDatabaseCompact)
    menu.addAction(action)

    menu.addSeparator()

    -- export
    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/sql")
    action.setText((("Export Database to SQL File...")))
    action.connect(#triggered, me, #slotDatabaseExportSQL)
    menu.addAction(action)

    isMemory = (me.pDatabases[currItem.text(0)]=":memory:")
    if isMemory then
      action = $.Qt.Action.new(menu)
      action.setIcon(":/icons/db_save")
      action.setText((("Export Memory Database to SQLite File")))
      action.connect(#triggered, me, #slotDatabaseExportMemory) -- slotDatabaseExportMemory
      menu.addAction(action)
    end if

    menu.addSeparator()

    if isMain then
      action = $.Qt.Action.new(menu)
      action.setText((("Close Database")))
      action.connect(#triggered, me, #slotFileClose)
      menu.addAction(action)
    else
      action = $.Qt.Action.new(menu)
      action.setText((("Detach Database")))
      action.connect(#triggered, me, #slotDetach)
      menu.addAction(action)
    end if

  "tables":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/table_create")
    action.setText((("Add Table")))
    action.connect(#triggered, me, #slotTableCreate)
    menu.addAction(action)

    menu.addSeparator()

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/csv")
    action.setText((("Import Table from CSV File...")))
    action.connect(#triggered, me, #slotTableImportCSV)
    menu.addAction(action)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/json")
    action.setText((("Import Table from JSON File...")))
    action.connect(#triggered, me, #slotTableImportJSON)
    menu.addAction(action)

  "indexes":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/index_create")
    action.setText((("Add Index")))
    action.connect(#triggered, me, #slotIndexCreate)
    menu.addAction(action)

  "views":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/view_create")
    action.setText((("Add View")))
    action.connect(#triggered, me, #slotViewCreate)
    menu.addAction(action)

  "triggers":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/trigger_create")
    action.setText((("Add Trigger")))
    action.connect(#triggered, me, #slotTriggerCreate)
    menu.addAction(action)

  "table":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/table_modify")
    action.setText((("Rename Table")))
    action.connect(#triggered, me, #slotTableRename)
    menu.addAction(action)

    menu.addSeparator()

    action = $.Qt.Action.new(menu)
    action.setText((("Export Table to SQL File...")))
    action.setIcon(":/icons/sql")
    action.connect(#triggered, me, #slotTableExportSQL)
    menu.addAction(action)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/csv")
    action.setText((("Export Table to CSV File...")))
    action.connect(#triggered, me, #slotTableExportCSV)
    menu.addAction(action)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/json")
    action.setText((("Export Table to JSON File...")))
    action.connect(#triggered, me, #slotTableExportJSON)
    menu.addAction(action)

    menu.addSeparator()

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/field_add")
    action.setText((("Add Field")))
    action.connect(#triggered, me, #slotFieldAdd)
    menu.addAction(action)

    menu.addSeparator()

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/table_delete")
    action.setText((("Drop Table")))
    action.connect(#triggered, me, #slotTableDelete)
    menu.addAction(action)

  "index":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/index_delete")
    action.setText((("Drop Index")))
    action.connect(#triggered, me, #slotIndexDelete)
    menu.addAction(action)

  "view":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/run")
    action.setText((("Execute View")))
    action.connect(#triggered, me, #slotViewExecute)
    menu.addAction(action)

    menu.addSeparator()

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/view_delete")
    action.setText((("Drop View")))
    action.connect(#triggered, me, #slotViewDelete)
    menu.addAction(action)

  "trigger":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/trigger_delete")
    action.setText((("Drop Trigger")))
    action.connect(#triggered, me, #slotTriggerDelete)
    menu.addAction(action)

  "field":
    menu = $.Qt.Menu.new(me.pMainWin)

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/field_edit")
    action.setText((("Edit Field")))
    action.connect(#triggered, me, #slotFieldEdit)
    menu.addAction(action)

    menu.addSeparator()

    action = $.Qt.Action.new(menu)
    action.setIcon(":/icons/field_delete")
    action.setText((("Drop Field")))
    action.connect(#triggered, me, #slotFieldDelete)
    menu.addAction(action)

  end case

  if not voidP(menu) then menu.exec()
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableRename (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  tableName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)
  newName = me.getText("Rename table", "Enter new name:", 0, tableName)
  if voidP(newName) or newName=tableName then return
  newName = $.string.trim(newName)
  sql = "ALTER TABLE #.# RENAME TO #"
  ok = me.pSX.sqlite_exec(sql, [dbName, tableName, newName], me.pErr)
  if ok then
    me.stat((("Table successfully renamed")))

    currItem.setText(0, newName)

    -- update pTableInfo
    info = me.pTableInfo[dbName][tableName]
    me.pTableInfo[dbName].deleteProp(tableName)
    me.pTableInfo[dbName][newName] = info

    -- update pComboBoxBrowseTable
    index = me.pComboBoxBrowseTable.findText(dbName&"."&tableName)
    if index>=0 then me.pComboBoxBrowseTable.setItemText(index, dbName&"."&newName)

  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableDelete (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  tableName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)
  sql = "DROP TABLE #.#"
  ok = me.pSX.sqlite_exec(sql, [dbName, tableName], me.pErr)
  if ok then
    me.stat((("Table successfully dropped")))
    me.showDbStructure()
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotIndexDelete (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  indexName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)
  sql = "DROP INDEX #.#"
  ok = me.pSX.sqlite_exec(sql, [dbName, indexName], me.pErr)
  if ok then
    me.stat((("Index successfully dropped")))
    me.showDbStructure()
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotViewDelete (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  viewName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)
  sql = "DROP VIEW #.#"
  ok = me.pSX.sqlite_exec(sql, [dbName, viewName], me.pErr)
  if ok then
    me.stat((("View successfully dropped")))
    me.showDbStructure()
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotTriggerDelete (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  triggerName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)
  sql = "DROP TRIGGER #.#"
  ok = me.pSX.sqlite_exec(sql, [dbName, triggerName], me.pErr)
  if ok then
    me.stat((("Trigger successfully dropped")))
    me.showDbStructure()
  else
    me.err(me.pErr[1])
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotFieldDelete (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  fieldName = currItem.text(0)
  tableName = currItem.parent().text(0)
  dbName = currItem.parent().parent().parent().text(0)

  tmpName = tableName&random(the maxinteger)

  sql = "BEGIN TRANSACTION;"
  fields = ""

  -- create a copy with all fields except fieldName
  put "CREATE TABLE "&tmpName&"(" after sql
  repeat with f in me.pTableInfo[dbName][tableName]
    if f[#name]=fieldName then next repeat

    put f[#name] && f[#type] after sql
    if f[#type]="INTEGER" and f[#pk] then
      put " PRIMARY KEY" after sql
    end if
    if f[#notnull] then
      put " NOT NULL" after sql
    end if
    if not voidP(f[#dflt_value]) then
      put " DEFAULT "&f[#dflt_value] after sql
    end if
    put "," after sql

    put f[#name]&"," after fields
  end repeat
  delete the last char of sql
  delete the last char of fields
  put ");" after sql

  tableNameFull = dbName&"."&tableName
  put "INSERT INTO "&tmpName&" SELECT "&fields&" FROM "&tableNameFull&";" after sql
  put "DROP TABLE "&tableNameFull&";" after sql
  put "ALTER TABLE "&tmpName&" RENAME TO "&tableName&";" after sql
  put "COMMIT;" after sql

  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if ok then
    me.stat((("Field successfully dropped")))
    currItem.parent().removeChild(currItem)

    me.updateTableInfo(tableName, currItem.parent(), dbName)
  else
    me.err(me.pErr[1])
    me.pSX.sqlite_exec("ROLLBACK;")
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotFieldAdd (me)
  -- reset dialog
  me.pDialogFieldLineEditName.setText("")
  me.pDialogFieldComboBoxType.setCurrentIndex(0)
  me.pDialogFieldLineEditDefault.setText("")
  me.pDialogFieldCheckBoxNotNull.setChecked(FALSE)

  me.pDialogField.setProp(#field, VOID)
  me.pDialogField.open()
end

----------------------------------------
-- @callback
----------------------------------------
on slotFieldEdit (me)
  currItem = me.pTreeWidgetStructure.currentItem()

  schema = currItem.text(3)

  -- name
  fieldName = currItem.text(0)
  me.pDialogFieldLineEditName.setText(fieldName)

  -- type
  if schema contains " INTEGER PRIMARY KEY" then
    fieldType = "INTEGER PRIMARY KEY"
  else
    fieldType = currItem.text(2)
  end if
  index = me.pDialogFieldComboBoxType.findText(fieldType)
  if index<0 then
    me.pDialogFieldComboBoxType.addItem(fieldType)
    index = me.pDialogFieldComboBoxType.count_()-1
  end if
  me.pDialogFieldComboBoxType.setCurrentIndex(index)

  -- default
  if schema contains " DEFAULT " then
    fieldDefault = schema.word[schema.word.count]
  else
    fieldDefault = ""
  end if
  me.pDialogFieldLineEditDefault.setText(fieldDefault)

  -- not null?
  notNull = (schema contains "NOT NULL")
  me.pDialogFieldCheckBoxNotNull.setChecked(notNull)

  me.pDialogField.setProp(#field, fieldName)
  me.pDialogField.open()
end

----------------------------------------
-- @callback
----------------------------------------
on slotDialogEditFieldAccepted (me)
  if voidP(me.pDialogField[#field]) then
    me.addField()
  else
    me.editField()
  end if
end

----------------------------------------
--
----------------------------------------
on addField (me)

  -- name
  fieldName = $.string.trim(me.pDialogFieldLineEditName.text())
  if fieldName="" then
    me.err("Name cannot be empty")
    return
  end if

  -- type
  fieldType = $.string.trim(me.pDialogFieldComboBoxType.currentText())
  if fieldType="" then
    me.err("Type cannot be empty")
    return
  end if

  -- default
  fieldDefault = $.string.trim(me.pDialogFieldLineEditDefault.text())

  fieldTypeFull = fieldType

  if me.pDialogFieldCheckBoxNotNull.isChecked() then
    put " NOT NULL" after fieldTypeFull
  end if

  if fieldDefault<>"" then
    put " DEFAULT "&fieldDefault after fieldTypeFull
  end if

  currItem = me.pTreeWidgetStructure.currentItem()
  tableName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)

  if dbName="main" then
    tableNameFull = tableName
  else
    tableNameFull = dbName&"."&tableName
  end if

  ----------------------------------------
  -- a) using ALTER TABLE (limited)
  ----------------------------------------
  --sql = "ALTER TABLE "&tableNameFull&" ADD COLUMN `"&fieldName&"`" && fieldTypeFull

  ----------------------------------------
  -- b) using a temp. table
  ----------------------------------------
  tmpName = tableNameFull&random(the maxinteger)

  sql = "BEGIN TRANSACTION;"
  put "CREATE TABLE "&tmpName&"(" after sql

  repeat with f in me.pTableInfo[dbName][tableName]
    put f[#name] && f[#type] after sql
    if f[#type]="INTEGER" and f[#pk] then
      put " PRIMARY KEY" after sql
    end if
    if f[#notnull] then
      put " NOT NULL" after sql
    end if
    if not voidP(f[#dflt_value]) then
      put " DEFAULT "&f[#dflt_value] after sql
    end if
    put "," after sql
  end repeat
  put fieldName && fieldTypeFull after sql
  put ");" after sql

  put "INSERT INTO "&tmpName&" SELECT *,NULL FROM "&tableNameFull&";" after sql
  put "DROP TABLE "&tableNameFull&";" after sql
  put "ALTER TABLE "&tmpName&" RENAME TO "&tableName&";" after sql
  put "COMMIT;" after sql
  put sql

  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if not ok then
    me.err(me.pErr[1])
    me.pSX.sqlite_exec("ROLLBACK;")
    return
  end if

  me.stat((("Field successfully added")))
  childItem = $.Qt.TreeWidgetItem.new()
  childItem.setIcon(0, ":/icons/field")
  childItem.setData(0, $.Qt.UserRole, "field")
  childItem.setText(0, fieldName)
  childItem.setText(1, "field")
  if fieldType starts "INTEGER PRIMARY KEY" then
    fieldType = "INTEGER"
  end if
  childItem.setText(2, fieldType)
  childItem.setText(3, "`"&fieldName&"`"&&fieldTypeFull)
  currItem.addChild(childItem)

  me.updateTableInfo(tableName, currItem, dbName)

  -- close the dialog
  me.pDialogField.close()
end

----------------------------------------
--
----------------------------------------
on editField (me)
  fieldNameOld = me.pDialogField[#field]

  -- name
  fieldName = $.string.trim(me.pDialogFieldLineEditName.text())
  if fieldName="" then
    me.err("Name cannot be empty")
    return
  end if

  -- type
  fieldType = $.string.trim(me.pDialogFieldComboBoxType.currentText())
  if fieldType="" then
    me.err("Type cannot be empty")
    return
  end if

  -- default
  fieldDefault = $.string.trim(me.pDialogFieldLineEditDefault.text())

  fieldTypeFull = fieldType
  if me.pDialogFieldCheckBoxNotNull.isChecked() then
    put " NOT NULL" after fieldTypeFull
  end if
  if fieldDefault<>"" then
    put " DEFAULT "&fieldDefault after fieldTypeFull
  end if

  currItem = me.pTreeWidgetStructure.currentItem()
  tableName = currItem.parent().text(0)
  dbName = currItem.parent().parent().parent().text(0)
  if dbName="main" then
    tableNameFull = tableName
  else
    tableNameFull = dbName&"."&tableName
  end if
  tmpName = tableNameFull&random(the maxinteger)

  sql = "BEGIN TRANSACTION;"

  put "CREATE TABLE "&tmpName&"(" after sql
  repeat with f in me.pTableInfo[dbName][tableName]
    if f[#name]=fieldNameOld then
      put fieldName && fieldTypeFull&"," after sql
    else
      put f[#name] && f[#type] after sql
      if f[#type]="INTEGER" and f[#pk] then
        put " PRIMARY KEY" after sql
      end if
      if f[#notnull] then
        put " NOT NULL" after sql
      end if
      if not voidP(f[#dflt_value]) then
        put " DEFAULT "&f[#dflt_value] after sql
      end if
      put "," after sql
    end if
  end repeat
  delete the last char of sql
  put ");" after sql

  put "INSERT INTO "&tmpName&" SELECT * FROM "&tableNameFull&";" after sql
  put "DROP TABLE "&tableNameFull&";" after sql
  put "ALTER TABLE "&tmpName&" RENAME TO "&tableName&";" after sql
  put "COMMIT;" after sql

  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)
  if not ok then
    me.err(me.pErr[1])
    me.pSX.sqlite_exec("ROLLBACK;")
    return
  end if

  me.stat((("Field successfully changed")))

  currItem.setText(0, fieldName)
  if fieldType starts "INTEGER PRIMARY KEY" then
    fieldType = "INTEGER"
  end if
  currItem.setText(2, fieldType)
  currItem.setText(3, "`"&fieldName&"`" && fieldTypeFull)

  me.updateTableInfo(tableName, currItem.parent(), dbName)

  -- close the dialog
  me.pDialogField.close()
end

----------------------------------------
-- @callback
----------------------------------------
on slotStructureItemExpanded (me, widget, index)
  me.pTreeWidgetStructure.resizeColumnToContents(0)
end

----------------------------------------
-- @callback
----------------------------------------
on slotDialogEditAccepted (me)
  currItem = me.pDialogEdit[#item]
  col = currItem.column()
  row = currItem.row()

  -- get table
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  _player.itemDelimiter = "."
  dbName = tableNameFull.item[1]
  tableName = tableNameFull.item[2]

  -- get ROWID
  ROWID = currItem.data($.Qt.UserRole)

  -- get fieldName
  if me.pShowROWID and col=0 then
    fieldName = "ROWID"
  else
    info = me.pTableInfo[dbName][tableName][col+(not me.pShowROWID)]
    fieldName = info[#name]
    --isRowidAlias = (info[#type]="INTEGER" and info[#pk]=1)
  end if

  isNull = me.pDialogEditCheckBoxNull.isChecked()

  if isNull then
    newVal = VOID
  else
    utf8Str = me.pDialogEditPlainTextEditValue.toPlainText()

    -- check if this a BLOB edit
    dataType = currItem.data($.Qt.UserRole+1)

    case dataType of
    "bytearray":
      ba = me.hexToBytes(utf8Str)
      newVal = sqlite_bytearray_to_binary_string(ba)

    "string":
      -- convert UTF-8 to encoding
      if me.pEncoding<>"utf-8" and utf8Str.length>0 then
        tmp = bytearray()
        tmp.writeString(utf8Str, me.pEncoding)
        tmp.position = 5
        tmp = tmp.readByteArray(tmp.length-4)
        newVal = sqlite_bytearray_to_binary_string(tmp)
      else
        newVal = utf8Str
      end if

      otherwise:
        newVal = utf8Str
    end case
  end if

  -- TODO: ignore if no changes were made?

  sql = "UPDATE "&tableNameFull&" SET "&fieldName&"=# WHERE ROWID="&ROWID
  ok = me.pSX.sqlite_exec(sql, [newVal], me.pErr)
  if not ok then
    me.err(me.pErr[1])
    return
  end if

  me.stat((("Record successfully changed")))

  -- reload table
  me.showTable(tableNameFull, -me.pBrowseRowsPerPage, row)

  -- close the dialog
  me.pDialogEdit.close()
end

----------------------------------------
-- @callback
----------------------------------------
on slotPlainTextEditValueChanged (me)
  if me.pDialogEditPlainTextEditValue.toPlainText()="" then return
  me.pDialogEditCheckBoxNull.setChecked(FALSE)
end

----------------------------------------
-- @callback
----------------------------------------
on slotCheckBoxNullToggled (me, widget, flag)
  if flag then
    me.pDialogEditPlainTextEditValue.clear()
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableCreate (me)
  tableName = me.getText("New table", (("Enter table name:")))
  if voidP(tableName) or tableName="" then return

  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.parent().text(0)

--  sql = "CREATE TABLE #.#(id INTEGER PRIMARY KEY)"
--  ok = me.pSX.sqlite_exec(sql, [dbName, tableName], me.pErr)

  sql = "CREATE TABLE "&dbName&"."&tableName&"(id INTEGER PRIMARY KEY)"
  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)

  if not ok then
    me.err(me.pErr[1])
    return FALSE
  end if
  me.showDbStructure()
  return TRUE
end

----------------------------------------
-- @callback
----------------------------------------
on slotIndexCreate (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.parent().text(0)
  if dbName="main" then dbName = ""
  else put "." after dbName

  sql = "CREATE INDEX "&dbName&"<index-name> ON "&dbName&"<table-name>(<fields>);"
  me.pPlainTextEditSQL.setPlainText(sql)
  --me.pPlainTextEditSQL.raise()
  tabWidget = me.pMainWin.findChild("mainTab", #TabWidget)
  tabWidget.setCurrentIndex(2)
end

----------------------------------------
-- @callback
----------------------------------------
on slotViewCreate (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.parent().text(0)
  if dbName="main" then dbName = ""
  else put "." after dbName

  sql = "CREATE VIEW "&dbName&"<view-name> AS SELECT <fields> FROM "&dbName&"<table-name> WHERE <clause>;"
  me.pPlainTextEditSQL.setPlainText(sql)
  tabWidget = me.pMainWin.findChild("mainTab", #TabWidget)
  tabWidget.setCurrentIndex(2)
end

----------------------------------------
-- @callback
----------------------------------------
on slotTriggerCreate (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.parent().text(0)
  if dbName="main" then dbName = ""
  else put "." after dbName

  sql = "CREATE TRIGGER "&dbName&"<trigger-name> [BEFORE|AFTER] <event>"&$.CR&\
  "ON "&dbName&"<table-name>"&$.CR&\
  "BEGIN"&$.CR&\
  "  -- Trigger logic goes here...."&$.CR&\
  "END;"
  me.pPlainTextEditSQL.setPlainText(sql)
  tabWidget = me.pMainWin.findChild("mainTab", #TabWidget)
  tabWidget.setCurrentIndex(2)
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableExportSQL (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  tableName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)

  dir = $.PATH & tableName & ".sql"
  filter = "SQL Files (*.sql);;All Files (*.*)"
  fn = $.Qt.FileDialog.getSaveFileName(me.pMainWin, (("Save SQL dump as...")), dir, filter)
  if fn="" then return
  fn = $.@(fn)

  -- get table
  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='table' AND tbl_name='"&tableName&"'"
  tables = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)
  if voidP(tables) then
    me.err(pErr[1])
    return
  end if

  fp = $.file.fopen(fn, "w")
  if fp=FALSE then
    me.err("File could not be created")
    return
  end if

  $.file.fwritestring(fp, "BEGIN TRANSACTION;"&me.pSqlExportEOL)

  -- CREATE part
  $.file.fwritestring(fp, tables[1]["sql"]&me.pSqlExportEOL)

  -- INSERT part
  sql = "SELECT * FROM "&tableName
  data = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)
  if voidP(data) then
    me.err(pErr[1])
    $.file.fclose(fp)
    $.file.delete(fn)
    return
  end if

  repeat with row in data
    columnValue = [:]
    if me.pSqlExportFullInserts then columnList = []
    cnt = row.count
    repeat with i = 1 to cnt
      columnValue[row.getPropAt(i)] = "'"&sqlite_escape_string(string(row[i]))&"'"
      if me.pSqlExportFullInserts then
        columnList.add(string(row.getPropAt(i)))
      end if
    end repeat
    $.file.fwritestring(fp, "INSERT INTO ")
    if me.pSqlExportFullInserts then
      $.file.fwritestring(fp, " ("&$.string.implode(", ", columnList)&")") -- FOR FULL INSERTS
    end if
    $.file.fwritestring(fp, " VALUES ("&implode(", ", columnValue)&")" &me.pSqlExportEOL)
  end repeat

  $.file.fwritestring(fp, "COMMIT;"&me.pSqlExportEOL)
  $.file.fclose(fp)
  me.stat("Table successfully exported")
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableExportCSV (me)
  currItem = me.pTreeWidgetStructure.currentItem()

  tableName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)

  dir = $.PATH & tableName & ".csv"
  filter = "CSV Files (*.csv);;All Files (*.*)"
  fn = $.Qt.FileDialog.getSaveFileName(me.pMainWin, (("Save JSON file as...")), dir, filter)
  if fn="" then return
  fn = $.@(fn)

  fp = $.file.fopen(fn, "w")
  if fp=FALSE then
    me.err("File could not be created")
    return
  end if

  -- @TODO add stream write method to CSV lib

  -- add headers
  row = []
  repeat with f in me.pTableInfo[dbName][tableName]
    row.add(f[#name])
  end repeat
  str = me.pCsvEnclosure & $.string.implode(me.pCsvEnclosure&me.pCsvDelim&me.pCsvEnclosure, row) & me.pCsvEnclosure
  $.file.fwritestring(fp, str)
  $.file.fwritestring(fp, me.pCsvEOL)
  fieldCnt = row.count

  -- add data
  sql = "SELECT * FROM "&dbName&"."&tableName
  res = me.pSX.sqlite_fetch(sql, $.sqlite.ResultList, me.pErr)
  repeat with row in res
    if me.pCsvEnclosure<>"" then
      -- double enc when found in strings
      repeat with i = 1 to fieldCnt
        v = row[i]
        if stringP(v) then
          tmp = $.string.explode(me.pCsvEnclosure, v)
          if tmp.count then
            row[i] = $.string.implode(me.pCsvEnclosure&me.pCsvEnclosure, tmp)
          end if
        end if
      end repeat
    end if
    str = me.pCsvEnclosure & $.string.implode(me.pCsvEnclosure&me.pCsvDelim&me.pCsvEnclosure, row) & me.pCsvEnclosure
    $.file.fwritestring(fp, str)
    $.file.fwritestring(fp, me.pCsvEOL)
  end repeat

  $.file.fclose(fp)
  me.stat("Table successfully exported")
end

----------------------------------------
-- @callback
----------------------------------------
on slotTableExportJSON (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  tableName = currItem.text(0)
  dbName = currItem.parent().parent().text(0)

  dir = $.PATH & tableName & ".json"
  filter = "JSON Files (*.json);;All Files (*.*)"
  fn = $.Qt.FileDialog.getSaveFileName(me.pMainWin, (("Save JSON file as...")), dir, filter)
  if fn="" then return
  fn = $.@(fn)

  fp = $.file.fopen(fn, "w")
  if fp=FALSE then
    me.err("File could not be created")
    return
  end if

  -- @TODO add stream write method to JSON lib

  -- get complete table as list of propLists
  data = []
  sql = "SELECT * FROM "&dbName&"."&tableName
  res = me.pSX.sqlite_fetch(sql, $.sqlite.ResultStringProps, me.pErr)
  repeat with row in res
    data.add(row)
  end repeat

  -- encode
  str = $.json.encode(data)

  -- save to file
  $.file.fwritestring(fp, str)
  $.file.fclose(fp)
  me.stat("Table successfully exported")
end

----------------------------------------
-- @callback
----------------------------------------
on slotDatabaseExportMemory (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.text(0)

  -- get filename
  dir = $.PATH & dbName & ".db"
  filter = "SQLite Files (*.db *.sqlite)"
  fn = $.Qt.FileDialog.getSaveFileName(me.pMainWin, (("Save memory database as...")), dir, filter)
  if string(fn)="" then return
  fn = $.@(fn)

  if $.file.exists(fn) then $.file.delete(fn)

  -- attach
  dbNameTmp = "tmp"&random(the maxinteger)
  sql = "ATTACH # AS #"
  ok = me.pSX.sqlite_exec(sql, [fn, dbNameTmp], me.pErr)
  if not ok then
    me.err(me.pErr[1])
    return
  end if

  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='table'"
  tables = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)

  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='index'"
  indexes = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)

  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='view'"
  views = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)

  sql = "SELECT * FROM "&dbName&".sqlite_master WHERE type='trigger'"
  triggers = me.pSX.sqlite_fetch(sql, $.sqlite.ResultSymbolProps, me.pErr)

  sql = "BEGIN TRANSACTION;"

  -- add tables
  repeat with table in tables
    tableName = table[#name]
    str = table[#sql]

    -- replace "CREATE TABLE " with "CREATE TABLE <dbNameTmp>."
    put dbNameTmp&"." after char 13 of str
    put str &";" after sql

    -- add the data rows
    sql2 = "SELECT * FROM "&dbName&"."&tableName
    data = me.pSX.sqlite_fetch(sql2, $.sqlite.ResultList, me.pErr)
    repeat with row in data
      columnValues = []
      cnt = row.count
      repeat with i = 1 to cnt
        columnValues.add("'"&sqlite_escape_string(string(row[i]))&"'")
      end repeat
      put "INSERT INTO "&dbNameTmp&"."&tableName after sql
      put " VALUES ("&$.string.implode(", ", columnValues)&");" after sql
    end repeat

  end repeat

  -- add indexes
  repeat with index in indexes
    str = index[#sql]

    -- replace "CREATE INDEX " with "CREATE INDEX <dbNameTmp>."
    put dbNameTmp&"." after char 13 of str
    put str &";" after sql
  end repeat

  -- add views
  repeat with view in views
    str = view[#sql]

    -- replace "CREATE VIEW " with "CREATE VIEW <dbNameTmp>."
    put dbNameTmp&"." after char 12 of str
    put str &";" after sql
  end repeat

  -- add triggers
  repeat with trigger in triggers
    str = trigger[#sql]

    -- replace "CREATE TRIGGER " with "CREATE TRIGGER <dbNameTmp>."
    put dbNameTmp&"." after char 15 of str
    put str &";" after sql
  end repeat

  put "COMMIT;" after sql

  ok = me.pSX.sqlite_exec(sql, 0, me.pErr)

  -- detach
  sql = "DETACH DATABASE #"
  me.pSX.sqlite_exec(sql, [dbNameTmp])

  if not ok then
    me.err(me.pErr[1])
    return
  end if

  me.stat("Memory database successfully exported")
end

----------------------------------------
-- @callback
----------------------------------------
on slotViewShowROWIDToggled (me, action, flag)
  me.pShowROWID = flag

  -- update browse table
  tableNameFull = me.pComboBoxBrowseTable.currentText()
  if tableNameFull<>"" then
    rowOffset = me.pCurrentRowOffset
    rowSelected = me.pTableWidgetBrowse.currentItem().row()
    me.showTable(tableNameFull, rowOffset, rowSelected)
  end if
end

----------------------------------------
-- @callback
----------------------------------------
on slotViewExecute (me)
  currItem = me.pTreeWidgetStructure.currentItem()
  dbName = currItem.parent().parent().text(0)
  viewName = currItem.text(0)
  viewNameFull = dbName&"."&viewName

  sql = "SELECT * FROM "&viewNameFull
  me.pPlainTextEditSQL.setPlainText(sql)
  me.slotPushButtonExecuteClicked()
  tabWidget = me.pMainWin.findChild("mainTab", #TabWidget)
  tabWidget.setCurrentIndex(2)
end
